function clientCmdJBC_announce(%msg, %duration, %isCountdown)
{
	if(!$JB::Online)
		return;

	if(%duration $= "")
		%duration = 4;
	
	if(%isCountdown && isObject(JBC_AnnounceText))
	{
		%container = JBC_AnnounceText;
		cancel(%container.delSched);
		cancel(%container.alertIcon.delSched);
		cancel(%container.textContainer.delSched);
		cancel(%container.alertSideBar.delSched);
		
		JBC_AnnounceText.textCtrl.setText("\c6" @ %msg);
	}
	else 
	{
		if(isObject(JBC_AnnounceText))
			JBC_AnnounceText.delete();
		
		%text = new GuiTextCtrl()
		{
			position = "30 -5";
			profile = JBC_AnnounceHUDLabelText;
		};
		%text.setText("\c6" @ %msg);
		
		%textX = getWord(%text.extent, 0);
		
		%res = getRes();
		
		%container = new GuiSwatchCtrl(JBC_AnnounceText)
		{
			color = "0 0 0 0";
			extent = %textX + 74 SPC 80;
			position = mFloor((getWord(%res, 0) / 2) - ((%textX + 74) / 2)) SPC getWord(%res, 1) - 180;
		};
		%container.textCtrl = %text;
		%container.textX = %textX;
		%container.alertIcon = new GuiBitmapCtrl()
		{
			extent = "64 64";
			position = (getWord(%container.extent, 0) / 2) - 32 SPC 0;
			bitmap = "Add-ons/Client_Jailbreak/res/icon/HUD_alert";
		};
		%container.alertSideBar = new GuiBitmapCtrl()
		{
			mColor =  "0 0 0 110";
			extent = "10 36";
			position = %textX + 100 SPC 14;
			bitmap = "Add-ons/Client_Jailbreak/res/sidebar";
		};
	
		%container.textContainer = new GuiSwatchCtrl()
		{
			color =  "0 0 0 110";
			extent = %textX + 30 SPC 36;
			position = %textX + 4 SPC "14";
		};
		
		%container.textContainer.add(%text);
		%container.add(%container.textContainer);
		%container.add(%container.alertSideBar);
		%container.add(%container.alertIcon);
		
		NewChatHUD.add(%container);
	}
	
	%container.alertIcon.tangoMoveTo("0 0", 500, "quad");
	%container.textContainer.tangoMoveTo("30 14", 500, "quad");
	%container.alertSideBar.tangoMoveTo(%container.textX + 60 SPC 14, 500, "quad");
	
	%container.alertIcon.delSched = %container.alertIcon.schedule(%duration * 1100, "tangoMoveTo", "0 150", 650, "elastic");
	%container.textContainer.delSched = %container.textContainer.schedule(%duration * 1100, "tangoMoveTo", "0 150", 650, "elastic");
	%container.alertSideBar.delSched = %container.alertSideBar.schedule(%duration * 1100, "tangoMoveTo", "0 150", 650, "elastic");
	%container.delSched = %container.schedule((%duration * 1000) + 1000, "delete");
}