function clientCmdJBC_hideDefaultHUD()
{
	if(!$JB::Online)
		return;
	PlayGui.schedule(20, "killPaint");
	PlayGui.schedule(20, "killInvHud");
	PlayGui.schedule(200, "killToolHud");
	$BrickAutoBuyDone = 1;
}

function clientCmdJBC_messageBoxOK(%title, %message)
{
	if(!$JB::Online)
		return;
	
	canvas.pushDialog(JBC_messageBoxOk);
	JBC_messageBoxOkWindow.schedule(25, "center");
	JBC_MessageBoxOkText.setText("<just:center><color:000000>" @ %message);
	JBC_MessageBoxOkText.forceReflow();
	
	%yExt = mClamp(getWord(JBC_MessageBoxOkText.extent, 1) + 80, 128, 1200);
	
	JBC_MessageBoxOkBottom.position = 0 SPC %yExt - 10;
	JBC_MessageBoxOkButton.position = 118 SPC %yExt - 50;
	JBC_MessageBoxOkBack.extent = 295 SPC %yExt - 30;
	JBC_MessageBoxOkWindow.resize(getWord(JBC_MessageBoxOkWindow.position, 0), getWord(JBC_MessageBoxOkWindow.position, 1), 295, %yExt);
}

function clientCmdJBC_MessageBoxYesNo(%title, %message, %okServerCmd)
{
	if(%message $= "Disconnect from the server?")
		%message = %message NL "<br>We suggest never leaving Jailbreak.";

	%okTag = getTag(%okServerCmd);
	%okTag = mFloor(%okTag);
	%okString = getTaggedString(%okTag);
	%okString = getSafeVariableName(%okString);

	if (%okString $= "")
		%okCallBack = "";
	else
		%okCallBack = "commandToServer(\'" @ %okString @ "\');";

	JBC_messageBoxYesNo.okCallBack = %okCallBack;
	canvas.pushDialog(JBC_messageBoxYesNo);
	JBC_messageBoxYesNoWindow.schedule(0, "center");
	JBC_MessageBoxYesNoText.setText("<just:center><color:000000>" @ %message);
	JBC_MessageBoxYesNoText.forceReflow();
	
	%yExt = mClamp(getWord(JBC_MessageBoxYesNoText.extent, 1) + 80, 128, 1200);
	
	JBC_MessageBoxYesButton.position = 206 SPC %yExt - 50;
	JBC_MessageBoxNoButton.position = 29 SPC %yExt - 50;

	JBC_MessageBoxYesNoBottom.position = 0 SPC %yExt - 10;
	JBC_MessageBoxYesNoBack.extent = 295 SPC %yExt - 30;
	JBC_MessageBoxYesNoWindow.resize(getWord(JBC_MessageBoxYesNoWindow.position, 0), getWord(JBC_MessageBoxYesNoWindow.position, 1), 295, %yExt);
}

function JBC_messageBoxYes()
{
	eval(JBC_messageBoxYesNo.okCallBack);
}

function JBC_moverSwatch::onMouseDown(%this, %mod, %point, %count)
{
	%this.startPos = %this.moveObject.position;
	%this.startMouse = canvas.getCursorPos();
	NewChatHUD.bringToFront(%this);
	%this.moverLoop();
	%this.moveObject.moved = 1;
} 

function JBC_moverSwatch::onMouseUp(%this, %mod, %point, %count)
{
	cancel(%this.moverLoop);
	%this.startPos = "";
	JBC_saveHUDPosition(%this.moveObject);
}

function JBC_moverSwatch::moverLoop(%this)
{
	cancel(%this.moverLoop);
	%ctrl = %this.moveObject;
	%cursorPos = canvas.getCursorPos();

	%xOffset = -(getWord(%this.startMouse, 0) - getWord(%cursorPos, 0));
	%yOffset = -(getWord(%this.startMouse, 1) - getWord(%cursorPos, 1));
	%ctrl.position = vectorAdd(%this.startPos, %xOffset SPC %yOffset);
	
	%this.moverLoop = %this.schedule(26, "moverLoop");
}

function JBC_saveHUDPosition(%ctrl)
{
	$JB::Pref["HUDPosition", %ctrl.getName()] = %ctrl.position;
	export("$JB::Pref*", "config/client/jailbreak.cs"); 
}

function clientCmdJBC_PlayGui_DisplayInfo(%bool)
{
	if(!%bool)
	{
		if(isObject(JBC_pingDisplay))
			JBC_pingDisplay.delete();
		if(isObject(JBC_fpsDisplay))
			JBC_fpsDisplay.delete();

		cancel($JBC::HudInfoLoop);
		return;
	}

	if(!isObject(JBC_pingDisplay))
	{
		new GuiTextCtrl(JBC_pingDisplay)
		{
			profile = "JBC_InfoDisplayProfile";
			extent = "100 20";
		};
		PlayGui.add(JBC_pingDisplay);
	}
	JBC_pingDisplay.position = 6 SPC getWord(getRes(), 1) - 24;

	if(!isObject(JBC_fpsDisplay))
	{
		new GuiTextCtrl(JBC_fpsDisplay)
		{
			profile = "JBC_InfoDisplayProfile";
			extent = "100 20";
		};
		PlayGui.add(JBC_fpsDisplay);
	}

	JBC_fpsDisplay.position = 6 SPC getWord(getRes(), 1) - 40;

	JBC_HUD_InfoLoop();
}

function JBC_HUD_InfoLoop()
{
	cancel($JBC::HudInfoLoop);

	%ping = serverConnection.getPing();
	%fps = mFloor(getWord(fpsMetricsCallback(), 2));

	JBC_fpsDisplay.setText("\c6FPS: " SPC %fps);
	JBC_pingDisplay.setText("\c6Ping:" SPC %ping);
	
	$JBC::HudInfoLoop = schedule(getNumKeyID() == 2143 ? 5 : 1000, 0, "JBC_HUD_InfoLoop");
}