// Gui Elements

if(!isObject(JBC_HUDLabelText)) new GuiControlProfile(JBC_HUDLabelText : GuiTextProfile)
{
	fontType = "Arial";
	fontSize = 16;
	justify = "center";
};

if(!isObject(JBC_TextProfile)) new GuiControlProfile(JBC_TextProfile : GuiTextProfile)
{
	fontColors[0] = "244 67 54 255";
	fontColors[1] = "26 35 126 255";
	fontColors[2] = "76 175 80 255";
	fontColors[3] = "255 235 59 255";
	fontColors[4] = "0 188 212 255";
	fontColors[5] = "156 39 176 255";
	fontColors[6] = "255 255 255 255";
	fontColors[7] = "96 125 139 255";
	fontColors[8] = "0 0 0 255";
	fontColors[9] = "20 20 20 255";
	fontSize = "18";
	fontType = "Arial Bold";
};


if(!isObject(JBC_InfoTextProfile)) new GuiControlProfile(JBC_InfoTextProfile : JBC_TextProfile)
{
	fontColors[7] = "120 120 120 255";
	fontColors[9] = "20 20 20 255";
	fontType = "Arial Bold";
	fontSize = 18;
};

if(!isObject(JBC_SmallInfoTextProfile)) new GuiControlProfile(JBC_SmallInfoTextProfile : JBC_TextProfile)
{
	fontColors[7] = "120 120 120 255";
	fontColors[9] = "20 20 20 255";
	fontType = "Airal";
	fontSize = 14;
	justify = "center";
};

if(!isObject(JBC_LargeHUDLabelText)) new GuiControlProfile(JBC_LargeHUDLabelText : JBC_TextProfile)
{
	fontType = "helvetica";
	fontSize = 22;
};


if(!isObject(JBC_WardenHUDLabelText)) new GuiControlProfile(JBC_WardenHUDLabelText : JBC_TextProfile)
{
	fontType = "Arial";
	fontSize = 24;
	justify = center;
};

if(!isObject(JBC_AnnounceHUDLabelText)) new GuiControlProfile(JBC_AnnounceHUDLabelText : JBC_LargeHUDLabelText)
{
	fontSize = 40;
};


if(!isObject(JBC_ColorScrollProfile)) new GuiControlProfile(JBC_ColorScrollProfile : ColorScrollProfile) 
{
	fontColors[0] = "255 0 0"; // Red
	fontColors[1] = "0 0 255"; // Blue
	fontColors[2] = "0 255 0"; // Green
	fontColors[3] = "255 255 0"; // Yellow
	fontColors[4] = "0 204 204"; // Teal
	fontColors[5] = "204 0 102"; // Purple
	fontColors[6] = "255 255 255"; // White
	fontColors[7] = "128 128 128"; // Gray
	fontColors[8] = "0 0 0"; // Black
	opaque = 1;
	fontType = "Arial Bold";
	fontSize = 16;
	border = 0;
};

if(!isObject(JBC_TabTextProfile)) new GuiControlProfile(JBC_TabTextProfile : JBC_TextProfile)
{
	justify = "center";
	fontSize = "16";
	fontType = "Arial";
};

if(!isObject(JBC_TabTextRightProfile)) new GuiControlProfile(JBC_TabTextRightProfile : JBC_TabTextProfile)
{
	justify = "right";
	fontType = "Arial Bold";
	fontSize = "18";
};

if(!isObject(JBC_TabTextCenterProfile)) new GuiControlProfile(JBC_TabTextCenterProfile : JBC_TabTextProfile)
{
	justify = "center";
	fontSize = "22";
};

if(!isObject(JBC_ScrollProfile)) new GuiControlProfile(JBC_ScrollProfile)
{
   fillColor = "0 0 0 0";
   borderColor = "35 50 0 176";
   border = "0";
   opaque = "1";

   fontColor = "70 70 70 255";
   fontColors[0] = "70 70 70";
   fontColors[1] = "255 70 70"; //R
   fontColors[2] = "70 255 70"; //G
   fontColors[3] = "70 70 255"; //B

   hasBitmapArray = true;
   bitmap = "Add-Ons/Client_Jailbreak/res/blockScroll";
};

if(!isObject(JBC_BlankWindowProfile)) new GuiControlProfile(JBC_BlankWindowProfile : GuiWindowProfile) 
{
    fillColor = "0 0 0 0";
    bitmap = "Add-Ons/Client_Jailbreak/res/blankWindow.png";
};

if(!isObject(JBC_ShapeNameProfile)) new GuiControlProfile(JBC_ShapeNameProfile : BlockChatTextProfile)
{
	fontType = "Tahoma Bold";
	fontSize = 18;
};
 
if(!isObject(JBC_TextListProfile)) new GuiControlProfile(JBC_TextListProfile : GuiTextListProfile)
{
	fillColorNA = "220 220 220 220";
	fontType = "Arial Bold";
	fontSize = "16";
	fillColor = "40 40 40 120";
	fontColorSEL = "20 20 20 220";
	fontColors[6] = "66 66 66 255";
	fontColors[7] = "60 105 148 240";
};
  
if(!isObject(JBC_TextEditProfile)) new GuiControlProfile(JBC_TextEditProfile : GuiTextEditProfile)
{
	bitmap = "Add-Ons/Client_Jailbreak/res/blankWindow";
	fontSize = 22 ;
	fontType = "Arial Bold";
	border = 0;
	fillColor = "0 0 0 0";
	fontColors[0] = "20 20 20 255"; 
	justify = center;
};

if(!isObject(JBC_CheckBoxProfile)) new GuiControlProfile(JBC_CheckBoxProfile : GuiCheckBoxProfile)
{
	fontColors[0] = "220 220 220 255";

	fontSize = 18;
	fontType = "Arial Bold";
};

if(!isObject(JBC_InfoDisplayProfile)) new GuiControlProfile(JBC_InfoDisplayProfile : BlockChatTextProfile)
{
	fontType = "Palatino Linotype";
	fontSize = 16;
};	

// Sounds

if(!isObject(JBC_Sound_Open)) new AudioProfile(JBC_Sound_Open)
{
	filename = "Add-Ons/Client_Jailbreak/res/sounds/open.wav";
 	 isLooping = false;
  	description = "AudioGui";
  	preload = true;
};

if(!isObject(JBC_Sound_Close)) new AudioProfile(JBC_Sound_Close : JBC_Sound_Open)
{
	filename = "Add-Ons/Client_Jailbreak/res/sounds/close.wav";
};

if(!isObject(JBC_Sound_Pop)) new AudioProfile(JBC_Sound_Pop : JBC_Sound_Open)
{
	filename = "Add-Ons/Client_Jailbreak/res/sounds/pop.wav";
};


if(!isObject(JBC_Sound_Buy)) new AudioProfile(JBC_Sound_Buy : JBC_Sound_Open)
{
	filename = "Add-Ons/Client_Jailbreak/res/sounds/buy.wav";
};

if(!isObject(JBC_Sound_Money)) new AudioProfile(JBC_Sound_Money : JBC_Sound_Open)
{
	filename = "Add-Ons/Client_Jailbreak/res/sounds/money.wav";
};

if(!isObject(JBC_Sound_Hover)) new AudioProfile(JBC_Sound_Hover : JBC_Sound_Open)
{
	filename = "Add-Ons/Client_Jailbreak/res/sounds/hover.wav";
};