function clientCmdJBC_checkForUpdates()
{
	if(isObject(JBC_Updater))
		JBC_Updater.delete();

	%res = getRes();
	%swatch = new GuiSwatchCtrl(JBC_Updater)
	{
		extent = "290 34";
		color = "200 200 200 255";
	};
	%swatch.position = (getWord(%res, 0) / 2) - getWord(%swatch.extent, 0) / 2 SPC -60;

	%swatch.add( %container = new GuiSwatchCtrl() 
	{
		extent = vectorSub(%swatch.extent, "2 2");
		position = "1 1";
		color = "54 79 103 230";
	});

	%container.add(new GuiAnimatedBitmapCtrl()
	{
		extent = "30 30";
		bitmap = "Add-Ons/Client_Jailbreak/res/load/load";
		framesPerSecond = 29;
		numFrames = 29;
		position = "250 1 ";
	});

	%container.add(new GuiBitmapCtrl()
	{
		extent = "26 26";
		bitmap = "Add-Ons/Client_Jailbreak/res/crown";
		position = "4 4";
	});

	%container.add(new GuiMLTextCtrl(JBC_UpdaterText)
	{
		position = "32 5";
		extent = "220 30";
	});
	
	if(LoadingGui.isAwake())
		LoadingGui.add(%swatch);
	else
		PlayGui.add(%swatch);

	%swatch.tangoMoveTo(getWord(%swatch.position, 0) SPC 0, 500, "quad");

	JBC_Updater_Display("Checking for Updates");
	schedule(1000, 0, "connectToUrl", "http://api.draked.me/cl/update.php?action=check", "GET", "", "JBC_Updater");
}

function JBC_Updater::handleText(%this, %text)
{
	$JBC::LatestVersion = %text;
	if(%text !$= $JBC::Version)
	{
		JBC_Updater_Display("Update Found!");
		JBC_update();
		return;
	}
	JBC_Updater_Display("We are up to date!");
	JBC_Updater_cleanup(true);
}

function JBC_updater::onDone(%this, %error)
{
	if(%error > 0)
	{
		JBC_Updater_Display("Error checking for updates!");
		echo("Error code:" SPC %error);
	}
}

function JBC_Updater_Display(%msg, %noEcho)
{
	if(!%noEcho)
		JBC_echo(%msg);
	JBC_UpdaterText.setText("<just:center><font:arial bold:24><color:E0E0E0>" @ %msg);
}

function JBC_update()
{
	if($JBC::lastUpdate + 30 > $Sim::Time)
	{
		JBC_echo("We just updated, slow down.");
		JBC_Updater_cleanup();
		return;
	}
	$JBC::lastUpdate = $Sim::Time;
	JBC_Updater_Display("Downloading Update");
	schedule(1000, 0, "connectToUrl", "http://api.draked.me/cl/update.php?action=download", "GET", "Add-Ons/Client_Jailbreak.zip", "JBC_Downloader");
}

function JBC_Downloader::onDone(%this, %error)
{
	if(%error > 0)
	{
		JBC_Updater_Display("Error Occured:" SPC %error);
		return;
	}

	discoverFile("Add-ons/Client_Jailbreak.zip");
	exec("Add-Ons/Client_Jailbreak/client.cs");
	JBC_Updater_Display("Update Successful!");

	schedule(2000, 0, "JBC_Updater_cleanup");
}

function JBC_Downloader::setProgressBar(%this, %progress)
{
	JBC_Updater_Display("Downloading - " @ mCeil(%progress * 100) @ "%", true);
}

function JBC_Updater_cleanup(%updated)
{
	JBC_Updater.schedule(1000, "tangoMoveTo", getWord(JBC_Updater.position, 0) SPC "-40", "500", "elastic");
	JBC_Updater.schedule(2001, "delete");
	commandToServer('JBC_handShake', $JBC::Version);
}